|
|
|
|
移动端

如何在Linux或者Unix下调试Bash Shell脚本

我如何能调试运行在 Linux 或者类 UNIX 的系统上的 bash shell 脚本呢?这是 Linux / Unix 系统管理员或新用户最常问的问题。shell 脚本调试可能是一项繁琐的工作(不容易阅读)。调试 shell 脚本有多种方法。

作者:Vivek Gite来源:Linux中国|2018-02-01 17:32


来自我的邮箱:

我写了一个 hello world 小脚本。我如何能调试运行在 Linux 或者类 UNIX 的系统上的 bash shell 脚本呢?

这是 Linux / Unix 系统管理员或新用户最常问的问题。shell 脚本调试可能是一项繁琐的工作(不容易阅读)。调试 shell 脚本有多种方法。

您需要传递 -x-v 参数,以在 bash shell 中浏览每行代码。

如何在 Linux 或者 UNIX 下调试 Bash Shell 脚本

如何在 Linux 或者 UNIX 下调试 Bash Shell 脚本

让我们看看如何使用各种方法调试 Linux 和 UNIX 上运行的脚本。

-x 选项来调试脚本

-x 选项来运行脚本:

  1. $ bash -x script-name
  2. $ bash -x domains.sh 

使用 set 内置命令

bash shell 提供调试选项,可以打开或关闭使用 set 命令

  • set -x : 显示命令及其执行时的参数。
  • set -v : 显示 shell 输入行作为它们读取的

可以在 shell 脚本本身中使用上面的两个命令:

  1. #!/bin/bash
  2. clear
  3.  
  4. # turn on debug mode
  5. set -x
  6. for f in *
  7. do
  8. file $f
  9. done
  10. # turn OFF debug mode
  11. set +x
  12. ls
  13. # more commands

你可以代替 标准释伴 行:

  1. #!/bin/bash

用以下代码(用于调试):

  1. #!/bin/bash -xv 

使用智能调试功能

首先添加一个叫做 _DEBUG 的特殊变量。当你需要调试脚本的时候,设置 _DEBUGon

  1. _DEBUG="on"

在脚本的开头放置以下函数:

  1. function DEBUG()
  2. {
  3. [ "$_DEBUG" == "on" ] && $@
  4. }

现在,只要你需要调试,只需使用 DEBUG 函数如下:

  1. DEBUG echo "File is $filename"

或者:

  1. DEBUG set -x
  2. Cmd1
  3. Cmd2
  4. DEBUG set +x

当调试完(在移动你的脚本到生产环境之前)设置 _DEBUGoff。不需要删除调试行。

  1. _DEBUG="off" # 设置为非 'on' 的任何字符

示例脚本:

  1. #!/bin/bash
  2. _DEBUG="on"
  3. function DEBUG()
  4. {
  5. [ "$_DEBUG" == "on" ] && $@
  6. }
  7.  
  8. DEBUG echo 'Reading files'
  9. for i in *
  10. do
  11. grep 'something' $i > /dev/null
  12. [ $? -eq 0 ] && echo "Found in $i file"
  13. done
  14. DEBUG set -x
  15. a=2
  16. b=3
  17. c=$(( $a + $b ))
  18. DEBUG set +x
  19. echo "$a + $b = $c"

保存并关闭文件。运行脚本如下:

  1. $ ./script.sh

输出:

  1. Reading files
  2. Found in xyz.txt file
  3. + a=2
  4. + b=3
  5. + c=5
  6. + DEBUG set +x
  7. + '[' on == on ']'
  8. + set +x
  9. 2 + 3 = 5

现在设置 _DEBUGoff(你需要编辑该文件):

  1. _DEBUG="off"

运行脚本:

  1. $ ./script.sh

输出:

  1. Found in xyz.txt file
  2. 2 + 3 = 5

以上是一个简单但非常有效的技术。还可以尝试使用 DEBUG 作为别名而不是函数。

调试 Bash Shell 的常见错误

Bash 或者 sh 或者 ksh 在屏幕上给出各种错误信息,在很多情况下,错误信息可能不提供详细的信息。

跳过在文件上应用执行权限

当你 编写你的第一个 hello world 脚本,您可能会得到一个错误,如下所示:

  1. bash: ./hello.sh: Permission denied

设置权限使用 chmod 命令:

  1. $ chmod +x hello.sh
  2. $ ./hello.sh
  3. $ bash hello.sh 

文件结束时发生意外的错误

如果您收到文件结束意外错误消息,请打开脚本文件,并确保它有打开和关闭引号。在这个例子中,echo 语句有一个开头引号,但没有结束引号:

  1. #!/bin/bash
  2.  
  3. ...
  4. ....
  5.  
  6. echo 'Error: File not found
  7. ^^^^^^^
  8. missing quote

还要确保你检查缺少的括号和大括号 {}

  1. #!/bin/bash
  2. .....
  3. [ ! -d $DIRNAME ] && { echo "Error: Chroot dir not found"; exit 1;
  4. ^^^^^^^^^^^^^
  5. missing brace }
  6. ... 

丢失像 fi,esac,;; 等关键字。

如果你缺少了结尾的关键字,如 fi;; 你会得到一个错误,如 “XXX 意外”。因此,确保所有嵌套的 ifcase 语句以适当的关键字结束。有关语法要求的页面。在本例中,缺少 fi

  1. #!/bin/bash
  2. echo "Starting..."
  3. ....
  4. if [ $1 -eq 10 ]
  5. then
  6. if [ $2 -eq 100 ]
  7. then
  8. echo "Do something"
  9. fi
  10.  
  11. for f in $files
  12. do
  13. echo $f
  14. done
  15.  
  16. # 注意 fi 丢失了 

在 Windows 或 UNIX 框中移动或编辑 shell 脚本

不要在 Linux 上创建脚本并移动到 Windows。另一个问题是编辑 Windows 10上的 shell 脚本并将其移动到 UNIX 服务器上。这将由于换行符不同而导致命令没有发现的错误。你可以使用下列命令 将 DOS 换行转换为 CR-LF 的Unix/Linux 格式

  1. dos2unix my-script.sh 

技巧 

技巧 1 - 发送调试信息输出到标准错误

[标准错误] 是默认错误输出设备,用于写所有系统错误信息。因此,将消息发送到默认的错误设备是个好主意:

  1. # 写错误到标准输出
  2. echo "Error: $1 file not found"
  3. #
  4. # 写错误到标准错误(注意 1>&2 echo 命令末尾)
  5. #
  6. echo "Error: $1 file not found" 1>&2 

技巧 2 - 在使用 vim 文本编辑器时,打开语法高亮

大多数现代文本编辑器允许设置语法高亮选项。这对于检测语法和防止常见错误如打开或关闭引号非常有用。你可以在不同的颜色中看到。这个特性简化了 shell 脚本结构中的编写,语法错误在视觉上截然不同。高亮不影响文本本身的意义,它只为你提示而已。在这个例子中,我的脚本使用了 vim 语法高亮:

!如何调试 Bash Shell 脚本,在 Linux 或者 UNIX 使用 Vim 语法高亮特性]7

技巧 3 - 使用 shellcheck 检查脚本

shellcheck 是一个用于静态分析 shell 脚本的工具。可以使用它来查找 shell 脚本中的错误。这是用 Haskell 编写的。您可以使用这个工具找到警告和建议。你可以看看如何在 Linux 或 类UNIX 系统上安装和使用 shellcheck 来改善你的 shell 脚本,避免错误和高效。

【编辑推荐】

  1. 迁移到Linux:图形操作环境
  2. 如何精通Linux上的文件搜索
  3. 五把Linux分区管理利器,你最喜欢哪个?
  4. 如何在Linux上用Fail2Ban保护服务器免受暴力攻击
  5. 最全Linux磁盘管理基础知识全汇总
【责任编辑:庞桂玉 TEL:(010)68476606】

点赞 0
分享:
大家都在看
猜你喜欢

读 书 +更多

Java EE 5 开发指南

本书是对Java EE各种技术之间互相协作的概览和补充。 本书还展示了如何编写JavaServer Page(JSP)页面或者企业级JavaBean(EJB):探讨了...

订阅51CTO邮刊

点击这里查看样刊

订阅51CTO邮刊